package bridge

//#cgo LDFLAGS: -lxyess -ldl
//#include <stdlib.h>
//#include <stdint.h>
//#include <xy_vod_sdk.hpp>
import "C"
import "unsafe"

func XY_SDK_INIT( ak string, sk string )int{

    c_ak := C.CString( ak )
    defer func(){
        C.free( unsafe.Pointer( c_ak ) )
    }()

    c_sk := C.CString( sk )
    defer func(){
        C.free( unsafe.Pointer( c_sk ) )
    }()

    return int( C.XY_SDK_INIT( c_ak, c_sk ) )
}

func XY_SDK_RELEASE(){
    C.XY_SDK_RELEASE()
}

func XY_SDK_REWRITE( url string )( int, string ){

    c_url := C.CString( url )
    defer func(){
        C.free( unsafe.Pointer( c_url ) )
    }()

    bufsize := C.int( len(url)*2 + 32 )
    pbuf := C.malloc( (C.size_t)(bufsize) )
    defer func(){
        C.free( pbuf )
    }()

    if errnum := C.XY_SDK_REWRITE( c_url, (*C.char)(pbuf), (C.uint32_t)(bufsize) ); errnum != 0 {
        return int(errnum), ""
    }

    return 0, C.GoString((*C.char)(pbuf))
}

func XY_SDK_VERSION()string{

    pbuf := C.malloc( 32 )
    defer func(){
        C.free( pbuf )
    }()

    C.XY_SDK_VERSION( (*C.char)(pbuf), 32 )

    return C.GoString( (*C.char)(pbuf) )
}

func XY_SDK_LOG( enable bool ){

    if enable{
        C.XY_SDK_LOG( 1 )
    }else{
        C.XY_SDK_LOG( 0 )
    }
}

func XY_SDK_GET_INFO( url string )string{

    c_url := C.CString( url )
    defer func(){
        C.free( unsafe.Pointer( c_url ) )
    }()

    pbuf := C.malloc( 128 )
    defer func(){
        C.free( pbuf )
    }()

    C.XY_SDK_GET_INFO( c_url, (*C.char)(pbuf), 128 )

    return C.GoString( (*C.char)(pbuf) )
}

func XY_STOP_TASK( url string){

    c_url := C.CString( url )
    defer func(){
        C.free( unsafe.Pointer( c_url ) )
    }()

    C.XY_STOP_TASK( c_url )
}
